#include "stdafx.h"
#include "SimpleForm.h"
#include "TiffHeader.h"

extern HBITMAP hb;
extern bool hb_exist;
extern char szFileName[MAX_PATH];
extern int XSize;
extern int YSize;
extern BITMAPINFO* lpbi;

unsigned char* buf;
int ReadLine(int XSize, char* Destination, FILE* f)
{
	unsigned char rc=0,cnt=0;
	int BytesInLine=0;

	while(BytesInLine<XSize)
		{
		  fread(&rc,1,1,f);
		  if(rc>192)// 
		  {
			cnt=rc-192;
			fread(&rc,1,1,f);
		//	for(int i=0;i<cnt;i++) buf[pos+i]=rc;
			memset(Destination+BytesInLine,(int)rc,cnt);
			BytesInLine+=cnt;
		  }
		  else
		  {
			  Destination[BytesInLine]=rc;
			  BytesInLine++;
		  }
		}
	return BytesInLine;
}

void OpenPCXFile(HWND hWnd)
{

	tagPCXHeader PCXHeader;
	char * Palette;
	bool IsPalPresent=false;
//      ( )
	FILE* f=fopen(szFileName,"rb");
	fread(&PCXHeader,sizeof(PCXHeader),1,f);

	XSize=PCXHeader.x2-PCXHeader.x1+1;
	YSize=PCXHeader.y2-PCXHeader.y1+1;
	if(PCXHeader.hard!=5) return;
	int TotalBytes=((PCXHeader.BytesPerLine+3)/4)*4;//   .
	if(hb_exist)
	{
		LocalFree(lpbi);
	}
	lpbi=(BITMAPINFO*)LocalAlloc(LPTR,sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*256);

	buf=new unsigned char[TotalBytes*YSize*PCXHeader.NPlanes];
	short NumColors=16;
	

			lpbi->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
			lpbi->bmiHeader.biWidth=XSize;
			lpbi->bmiHeader.biHeight=-YSize;
			lpbi->bmiHeader.biCompression=BI_RGB;
			lpbi->bmiHeader.biPlanes=1;
			lpbi->bmiHeader.biSizeImage=0;
			lpbi->bmiHeader.biBitCount=PCXHeader.BitPerPixel*PCXHeader.NPlanes;
			
			lpbi->bmiHeader.biXPelsPerMeter=100;
			lpbi->bmiHeader.biYPelsPerMeter=100;
			lpbi->bmiHeader.biClrUsed=0;
			lpbi->bmiHeader.biClrImportant=0;



	// 
	unsigned char rc=0;//12 - present
	fseek(f,-769,SEEK_END);
	
	
	fread(&rc,1,1,f);
	if(rc==12)
	{
		//256 color palette
		Palette=new char[256*3];
		IsPalPresent=true;
		fread(Palette,sizeof(char),256*3,f);
		NumColors=256;
	}
	else Palette=PCXHeader.ColorMap;

	for(int i=0;i<NumColors;i++)
	{
		lpbi->bmiColors[i].rgbRed=Palette[i*3];
		lpbi->bmiColors[i].rgbGreen=Palette[i*3+1];
		lpbi->bmiColors[i].rgbBlue=Palette[i*3+2];
		lpbi->bmiColors[i].rgbReserved=0;
	}
	
	
	fseek(f,128,SEEK_SET);


  


//       lp
  int lines=0;
 

  int pos=0;//    lp
  char* line=new char[TotalBytes];
  if(PCXHeader.NPlanes==1)
  {
  	  //   .


	while(lines<YSize)
	{
		ReadLine(XSize,line,f);		
		memcpy(buf+pos,line,XSize);
		pos=((XSize+3)/4)*lines*PCXHeader.BitPerPixel/2;//   bmp
		lines++;
	}
  }
  if(PCXHeader.NPlanes==3)
  {
	  
	while(lines<YSize)
	{
		int i=0;
		ReadLine(XSize,line,f);		//Red line
		for(;i<XSize;i++)
			buf[pos+i*3+2]=line[i];
		ReadLine(XSize,line,f);		//Green line
		for(i=0;i<XSize;i++)
			buf[pos+i*3+1]=line[i];

		ReadLine(XSize,line,f);		//Blue line
		for(i=0;i<XSize;i++)
			buf[pos+i*3+0]=line[i];

		lines++;
		pos=((XSize*PCXHeader.NPlanes+3)/4)*lines*4;//   bmp
		
		
	}

  }
	delete[] line;
	fclose(f);

	HDC LocalDC=GetDC(hWnd);
	if(hb_exist)DeleteObject(hb);
	hb=CreateDIBitmap(LocalDC,&(lpbi->bmiHeader),CBM_INIT,buf,lpbi,DIB_RGB_COLORS);
	hb_exist=true;
	ReleaseDC(hWnd,LocalDC);
	if(IsPalPresent)delete[] Palette;
	delete[] buf;

}
void OpenBMPFile(HWND hWnd)
{
	BITMAPFILEHEADER FileHeader;       /* bitmap file-header */
    PBITMAPINFOHEADER pInfoHeader;     /* bitmap info-header */
  
	FILE* f=fopen(szFileName,"rb");
	fread(&FileHeader,sizeof(BITMAPFILEHEADER),1,f);
	if(FileHeader.bfType!=0x4d42)
	{
		MessageBox(hWnd,"This file is corrupted","Incorrect format",MB_OK);
		return;
	}
	pInfoHeader=new BITMAPINFOHEADER;
	fread(pInfoHeader,sizeof(BITMAPINFOHEADER),1,f);
	
	DWORD NumColors=1<<pInfoHeader->biBitCount;
	if(pInfoHeader->biClrUsed) NumColors=pInfoHeader->biClrUsed;// biClrUsed  ,     ...
	if(pInfoHeader->biBitCount==24)NumColors=0;
	//   XSize   YSize;
	XSize=pInfoHeader->biWidth;
	YSize=pInfoHeader->biHeight;
	
	
	if(hb_exist)
	{
		LocalFree(lpbi);
		DeleteObject(hb);
	}
	lpbi=(PBITMAPINFO)LocalAlloc(LPTR,sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*NumColors);
	
	memcpy(lpbi,pInfoHeader,sizeof(BITMAPINFOHEADER));
	if(pInfoHeader->biBitCount<=8)
	fread(lpbi->bmiColors,sizeof(RGBQUAD)*NumColors,1,f);//  bmp-
	
	fseek(f,FileHeader.bfOffBits,SEEK_SET);
	int r;
	char* buf=new char[r=FileHeader.bfSize-FileHeader.bfOffBits+1];
	fread(buf,r-1,1,f);
	fclose(f);
	
	HDC LocalDC=GetDC(hWnd);
	hb=CreateDIBitmap(LocalDC,&(lpbi->bmiHeader),CBM_INIT,buf,lpbi,DIB_RGB_COLORS);
	hb_exist=true;
//	pBmpInfo->bmiHeader.biHeight=abs(pBmpInfo->bmiHeader.biHeight);
	
	delete[] buf;
	delete pInfoHeader;
	ReleaseDC(hWnd,LocalDC);	
	return;
}
template <class T> void rever(T& x)
{
	std::reverse((char*)&x,(char*)&x+sizeof(T));
}
void OpenTiffFile(HWND hWnd)
{
	bool BOrder=false;//if BOrder=true swap parts
	tagTiffHeader TiffHeader;
	tagIFDElement IFDEl;
	FILE* f=fopen(szFileName,"rb");
	fread(&TiffHeader,sizeof(tagTiffHeader),1,f);
	if(TiffHeader.ByteOrder==0x4d4d)BOrder=true;

	if(BOrder) rever(TiffHeader.FirstIFD);
	
	WORD NumEls=0;//-   
	fseek(f,TiffHeader.FirstIFD,SEEK_SET);
	fread(&NumEls,1,2,f);
	if(BOrder) rever(NumEls);

	//variables
	int BitsPerComponent=8;
	DWORD* StripOffset;//   
	WORD SamplesPerPixel=1;
	DWORD* StripByteCounts;//   
	WORD PlanarConfig=1;//  . =1 :RGBRGBRGB; =2: RRRGGGBBB
	DWORD PalOffset;// ( )
	WORD PhotoMetric;
	//DWORD StripByteCounts;
	DWORD RowsPerStrip;
	DWORD NumStrips=1;// 
	WORD temp;
	// .
	for(int i=0;i<NumEls;i++)
	{
		fread(&IFDEl,sizeof(tagIFDElement),1,f);
		if(BOrder)
		{rever(IFDEl.Tag);
		 rever(IFDEl.Type);
		 rever(IFDEl.Length);
		 rever(IFDEl.DataOffs);
		 if(IFDEl.Type==tiWord)IFDEl.DataOffs=HIWORD(IFDEl.DataOffs);
		}
		switch(IFDEl.Tag)
		{
		case ttImageWidth:
			if(IFDEl.Type==tiLong)
			{XSize=IFDEl.DataOffs;}
			else 
			{XSize=LOWORD(IFDEl.DataOffs);}
			

			break;
		case ttImageLength:
			if(IFDEl.Type==tiLong)YSize=IFDEl.DataOffs;
			else YSize=LOWORD(IFDEl.DataOffs);
			

			break;
		case ttBitsPerSample:
			if(IFDEl.Length==1)	BitsPerComponent=LOWORD(IFDEl.DataOffs);

			break;
		case ttCompression:
			if(LOWORD(IFDEl.DataOffs)!=1)return;
			break;
		case ttStripOffsets:
			{
				NumStrips=IFDEl.Length;
				StripOffset=new DWORD[IFDEl.Length];
				if(IFDEl.Length>1)
				{
					long fpos=ftell(f);//    
					fseek(f,IFDEl.DataOffs,SEEK_SET);//      
					if(IFDEl.Type==tiWord)
					{
						for(int i=0;i<IFDEl.Length;i++)
						{
							fread(&temp,sizeof(WORD),1,f);
							if(BOrder)rever(temp);
							StripOffset[i]=temp;
						}
					}
					else
					{	
						fread(&StripOffset[0],sizeof(DWORD),IFDEl.Length,f);
						if(BOrder)
						for(int i=0;i<IFDEl.Length;i++)
						{
							rever(StripOffset[i]);
						}
					}
					fseek(f,fpos,SEEK_SET);//    .
				}
				else
				{
					
					if(IFDEl.Type==tiLong)StripOffset[0]=IFDEl.DataOffs;
					else StripOffset[0]=LOWORD(IFDEl.DataOffs);
				}
				
			}
			break;
		case ttSamplesPerPixel:
			SamplesPerPixel=LOWORD(IFDEl.DataOffs);
			break;
		case ttStripByteCounts:
			
			StripByteCounts=new DWORD[IFDEl.Length];
			if(IFDEl.Length<2)
			{	
				if(IFDEl.Type==tiLong)StripByteCounts[0]=IFDEl.DataOffs;
				else StripByteCounts[0]=LOWORD(IFDEl.DataOffs);
			}
			else
			{
				DWORD fpos=ftell(f);
				fseek(f,IFDEl.DataOffs,SEEK_SET);
				if(IFDEl.Type==tiWord)
					{
						for(int i=0;i<IFDEl.Length;i++)
						{
							fread(&temp,sizeof(WORD),1,f);
							if(BOrder)rever(temp);
							StripByteCounts[i]=temp;
						}
					}
					else
					{	
						fread(&StripByteCounts[0],sizeof(DWORD),IFDEl.Length,f);
						if(BOrder)
						for(int i=0;i<IFDEl.Length;i++)
						{
							rever(StripByteCounts[i]);
						}
					}
				fseek(f,fpos,SEEK_SET);
			}
			break;
		case ttColorMap:
		
				PalOffset=IFDEl.DataOffs;
			break;
		case ttOrientation:
			break;
		case ttPlanarConfig:
			PlanarConfig=LOWORD(IFDEl.DataOffs);
			break;
		case ttRowsPerStrip:
			if(IFDEl.Type==tiLong)RowsPerStrip=IFDEl.DataOffs;
			else RowsPerStrip=LOWORD(IFDEl.DataOffs);
			break;
		case ttPhotoMetric:
			PhotoMetric=LOWORD(IFDEl.DataOffs);
			break;
		}
	}
	//   .
	WORD NumColors=1<<BitsPerComponent*SamplesPerPixel;
	if(hb_exist)
	{
		LocalFree(lpbi);
		DeleteObject(hb);
	}
	buf=new unsigned char[XSize*YSize*SamplesPerPixel];//   
	DWORD pos=0;//,     
	if(NumStrips==1)StripByteCounts[0]=XSize*YSize*SamplesPerPixel;
	for(i=0;i<NumStrips;i++)// - 
	{
		fseek(f,StripOffset[i],SEEK_SET);
		fread(buf+pos,1,StripByteCounts[i],f);
		pos+=StripByteCounts[i];
	}


	HDC LocalDC=GetDC(hWnd);
	if(PhotoMetric==3)
	{
		if(SamplesPerPixel==1)// 
		{
			lpbi=(BITMAPINFO*)LocalAlloc(LPTR,sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*NumColors);
			fseek(f,PalOffset,SEEK_SET);
			int i=0;
			WORD rc;
			for(;i<NumColors;i++)
			{
				fread(&rc,2,1,f);
				if(BOrder)rever(rc);
				lpbi->bmiColors[i].rgbRed=rc/256;
				lpbi->bmiColors[i].rgbReserved=0;
			}
			for(i=0;i<NumColors;i++)
			{
				if(BOrder)rever(rc);
				fread(&rc,2,1,f);
				lpbi->bmiColors[i].rgbGreen=rc/256;
			}
			for(i=0;i<NumColors;i++)
			{
				if(BOrder)rever(rc);
				fread(&rc,2,1,f);
				lpbi->bmiColors[i].rgbBlue=rc/256;
			}
			/*
			fseek(f,StripOffset[0],SEEK_SET);
			buf=new char[XSize*YSize*SamplesPerPixel];
			fread(buf,XSize*YSize,1,f);
		*/
			lpbi->bmiHeader.biBitCount=BitsPerComponent;
			lpbi->bmiHeader.biClrImportant=0;
			lpbi->bmiHeader.biClrUsed=0;
			lpbi->bmiHeader.biCompression=BI_RGB;
			lpbi->bmiHeader.biHeight=-YSize;
			lpbi->bmiHeader.biPlanes=1;
			lpbi->bmiHeader.biSize=40;//sizeof(BITMAPINFOHEADER)
			lpbi->bmiHeader.biSizeImage=0;
			lpbi->bmiHeader.biWidth=XSize;			
				
			hb=CreateDIBitmap(LocalDC,&(lpbi->bmiHeader),CBM_INIT,buf,lpbi,DIB_RGB_COLORS);
		}

	}
	else
		if(PhotoMetric==2)//rgb
		{
			lpbi=(BITMAPINFO*)LocalAlloc(LPTR,sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD));
			/*
			fseek(f,StripOffset[0],SEEK_SET);
			buf=new char[XSize*YSize*SamplesPerPixel];
			fread(buf,1,XSize*YSize*SamplesPerPixel,f);
			*/
			lpbi->bmiHeader.biBitCount=BitsPerComponent*SamplesPerPixel;
			lpbi->bmiHeader.biClrImportant=0;
			lpbi->bmiHeader.biClrUsed=0;
			lpbi->bmiHeader.biCompression=BI_RGB;
			lpbi->bmiHeader.biHeight=-YSize;
			lpbi->bmiHeader.biPlanes=1;
			lpbi->bmiHeader.biSize=40;//sizeof(BITMAPINFOHEADER)
			lpbi->bmiHeader.biSizeImage=0;
			lpbi->bmiHeader.biWidth=XSize;			

			hb=CreateDIBitmap(LocalDC,&(lpbi->bmiHeader),CBM_INIT,buf,lpbi,DIB_RGB_COLORS);

		}
		hb_exist=true;
	delete[] StripOffset;
	delete[] StripByteCounts;
	fclose(f);
	ReleaseDC(hWnd,LocalDC);
	delete[] buf;


}
bool SaveBMPFile(HWND hWnd, PBITMAPINFO pBmpInfo)
{
	HANDLE hFile;
	BITMAPFILEHEADER FileHeader;       /* bitmap file-header */
//    PBITMAPINFOHEADER pInfoHeader;     /* bitmap info-header */
    LPBYTE lpBits;              /* memory pointer */
	DWORD NumColors=1<<pBmpInfo->bmiHeader.biBitCount;
	if(pBmpInfo->bmiHeader.biClrUsed) NumColors=pBmpInfo->bmiHeader.biClrUsed;// biClrUsed  ,     ...
	if(pBmpInfo->bmiHeader.biBitCount==24)NumColors=0;

	
	HDC LocalDC=GetDC(hWnd);
	
	pBmpInfo->bmiHeader.biHeight=abs(pBmpInfo->bmiHeader.biHeight);

	if(!GetDIBits(LocalDC,hb,0,pBmpInfo->bmiHeader.biHeight,0,pBmpInfo,DIB_RGB_COLORS))//  
		return false;
	lpBits=new BYTE[pBmpInfo->bmiHeader.biSizeImage];//(LPBYTE)LocalAlloc(LPTR,pBmpInfo->bmiHeader.biSizeImage);
	if(!GetDIBits(LocalDC,hb,0,pBmpInfo->bmiHeader.biHeight,lpBits,pBmpInfo,DIB_RGB_COLORS))//  
		return false;
	
	
	//lets init structures;
	FileHeader.bfType=0x4d42;//"BM"
	FileHeader.bfReserved1=0;
	FileHeader.bfReserved2=0;
	FileHeader.bfOffBits=(DWORD)(sizeof(BITMAPFILEHEADER)+pBmpInfo->bmiHeader.biSize+sizeof(RGBQUAD)*NumColors);
	FileHeader.bfSize=FileHeader.bfOffBits+pBmpInfo->bmiHeader.biSizeImage;

	hFile=CreateFile(szFileName,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
	if(hFile==INVALID_HANDLE_VALUE) return false;//Error while opening the file
	DWORD res=0;
	//write fileheader
	if(!WriteFile(hFile,&FileHeader,sizeof(BITMAPFILEHEADER),&res,0))return false;
	//write bitmapinfo
	if(!WriteFile(hFile,pBmpInfo,pBmpInfo->bmiHeader.biSize+sizeof(RGBQUAD)*NumColors,&res,0))return false;
	//write image data
	if(!WriteFile(hFile,lpBits,pBmpInfo->bmiHeader.biSizeImage,&res,0))return false;
	CloseHandle(hFile);
	delete[] lpBits;
	return ReleaseDC(hWnd,LocalDC);	
}